# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name

    # All URL 
    download_dict = {
        "windows-x64": "https://downloads.nomachine.com/download/?id=8",
        "windows-x86": "https://downloads.nomachine.com/download/?id=9",
        "redhat_based-x64": "https://downloads.nomachine.com/download/?id=2",
        "debian_based-x64": "https://downloads.nomachine.com/download/?id=1",
        "macos-all": "https://downloads.nomachine.com/download/?id=7",
    }

    url = download_dict[control.target_os + "-" + ensure_list(control.architecture)[0]]

    # Getting latest version from official sources
    print("URL used is: %s" % url)
    for bs_search in bs_find_all(url, "a", "id", "link_download", proxies=proxies):
        if "nomachine_" in bs_search.get("href", ""):
            download_url = bs_search["href"]
            latest_bin = bs_search["href"].rsplit("/", 1)[-1]
            latest_bin_extension = latest_bin.rsplit(".", 1)[-1]
            version = latest_bin.split("_")[1]
            break

    # Downloading latest binaries
    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
        package_updated = True
    else:
        print("Binary is present: %s" % latest_bin)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))

    control.set_software_version(version)
    control.save_control_to_wapt()

    for f in glob.glob(f'*.{latest_bin_extension}'):
        if f != latest_bin:
            remove_file(f)

    # Validating or not update-package-sources
    return package_updated
